<?php
/**
* Admin DC plugins
* Version 1.0.1
*/

if(!class_exists('dcwp_plugin_admin')) {

	class dcwp_plugin_admin {

		var $hook 		= '';
		var $filename	= '';
		var $longname	= '';
		var $shortname	= '';
		var $optionname = '';
		var $homepage	= '';
		var $accesslvl	= 'manage_options';

		function __construct() {

			add_filter("plugin_action_links_{$this->filename}", array(&$this,'add_settings_link'));

			add_action('admin_menu', array(&$this,'add_option_page'));

			add_action("admin_print_styles-settings_page_{$this->hook}",array(&$this,'add_admin_styles'));

			add_action("admin_print_scripts-settings_page_{$this->hook}",array(&$this,'add_admin_scripts'));

		}

		function add_admin_styles() {

			wp_enqueue_style('dcwp_plugin_admin_css', WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname($this->filename)). '/css/admin.css');

		}

		function add_admin_scripts() {

			wp_enqueue_script('postbox');

			wp_enqueue_script('jquery');
			
			wp_enqueue_style('dcwp_plugin_admin_jquery', WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname($this->filename)). '/js/jquery.admin.js');

		}

		function add_option_page() {

			add_options_page($this->longname, $this->shortname, $this->accesslvl, $this->hook, array(&$this,'option_page'));

		}

		function add_settings_link($links) { 

			$settings_link = '<a href="options-general.php?page='.$this->hook.'">Settings</a>'; 

			array_unshift($links, $settings_link); 

			return $links; 

		}

		function dcwp_donate() {

			$content = '<p>All of our Wordpress plugins are created & supported for free. However ... we are always happy to receive any donations if you do find them useful!</p>';
			$content .= '<form name="_xclick" id="form-dcwp-donate" action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">';
			$content .= '<input type="hidden" name="cmd" value="_s-xclick">';
			$content .= '<input type="hidden" name="hosted_button_id" value="NVWNM7CSNMEHY">';
			$content .= '<input type="image" src="https://www.paypalobjects.com/WEBSCR-640-20110306-1/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!"><img alt="" border="0" src="https://www.paypalobjects.com/WEBSCR-640-20110306-1/nl_NL/i/scr/pixel.gif" width="1" height="1">';
			$content .= '</form>';

			$this->postbox($this->hook.'-donatebox','Is '.$this->shortname.' Useful?',$content);		

		}

		function latest_posts() {

			require_once(ABSPATH.WPINC.'/rss.php');  

			if ( $rss = fetch_rss( 'http://feeds.feedburner.com/DesignChemical' ) ) {

				$content = '<ul class="dcwp-rss">';

				$rss->items = array_slice( $rss->items, 0, 5 );

				foreach ( (array) $rss->items as $item ) {

					$content .= '<li class="dcwp-rss-item">';
					$content .= '<a target="_blank" href="'.clean_url( $item['link'], $protocolls=null, 'display' ).'">'. $item['title'] .'</a> ';
					$content .= '</li>';

				}
				$content .= '</ul><ul class="bullet">';
				$content .= '<li class="dcwp-icon-rss"><a href="http://feeds.feedburner.com/DesignChemical">Subscribe to our RSS feed</a></li>';
				$content .= '<li class="dcwp-icon-twitter"><a href="http://twitter.com/designchemical">Follow us on Twitter</a></li>';
				$content .= '</ul>';

			} else {

				$content = '<p>No updates..</p>';

			}

			$this->postbox($this->hook.'-latestpostbox','Latest from our blog ...',$content);

		}

		function likebox(){

			$content = '<ul class="bullet">';
			$content .= '<li><a href="http://wordpress.org/extend/plugins/'.$this->hook.'/" target="_blank"><strong>Rate it 5</strong></a> on the WordPress.org Plugin Directory</a></li>';
			$content .= '<li>Check out our other plugins - <a target="_blank" href="http://www.designchemical.com/blog/">Design Chemical</a></li>';
			$content .= '<li>Spread the word and tell others!</li>';
			$content .= '</ul>';

			$this->postbox($this->hook.'-likebox','Like this plugin?',$content);

		}

		function support_box() {

			$content = '<ul class="bullet">';
			$content .= '<li>Trouble installing or setting-up?</li>';
			$content .= '<li>Need help on customising the styles?</li>';
			$content .= '<li>Have a suggestion on how it can be improved?</li></ul>';
			$content .= '<p>Contact us via the <a target="_blank" href="'.$this->homepage.'#comments">plugin page comments form</a> on our blog or our online contact form</p>';

			$this->postbox($this->hook.'-support-box',"Need any help with ".$this->shortname."?",$content);

		}

		function postbox($id,$title,$content){

			?>

			<div id="<?php echo $id; ?>" class="postbox dcwp-box">				
				<h3 class="hndle"><span><?php echo $title; ?></span></h3>
				<div class="inside">
					<?php echo $content; ?>
				</div>
			</div>

			<?php			

		}

		function setup_admin_page($title,$subtitle) {

			?>

			<div class="wrap">
			  <h2><a href="http://www.designchemical.com/blog/" target="_blank" id="dcwp-avatar"></a><?php echo $title; ?></h2>
			  <div class="postbox-container" style="width:65%;">
			    <div class="metabox-holder">
				  <div class="meta-box-sortables">
				    <div class="postbox">
					  <h3 class="hndle"><span><?php echo $subtitle; ?></span></h3>
					  <div class="inside">
					  
			<?php

		}

		function close_admin_page() {

		?>

		</div></div></div></div></div></div>

		<div class="postbox-container" style="width:30%;">
			<div class="metabox-holder">	
				<div class="meta-box-sortables">						

					<?php

						$this->likebox();
						
						$this->support_box();

						$this->dcwp_donate();

						$this->latest_posts();
						
						$this->info_box();

					?>				

				</div>

			</div>

		</div>

	</div>

		<?php

		}

		function text_limit( $text, $limit, $finish = '...') {

			if( strlen( $text ) > $limit ) {

		    	$text = substr( $text, 0, $limit );

				$text = substr( $text, 0, - ( strlen( strrchr( $text,' ') ) ) );

				$text .= $finish;

			}

			return $text;

		}
	}
}